package actores.behaviours;

import jade.core.Agent;
import jade.core.behaviours.*;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import java.util.Random;


public class Buscona extends Agent 
{

	private int borracha = 0 ;	
	 private String[] nivel = {"nada","un poquito","muuuuuuuuuuuuuuy"};
	
	
	
	protected void setup()
	{
		// Genero un listado con las chicas
		
		DFAgentDescription listadoChicas = new DFAgentDescription();
		listadoChicas.setName( getAID() );
		ServiceDescription sd = new ServiceDescription();
		sd.setType("tipo-buscona");
		sd.setName( getLocalName() );
		listadoChicas.addServices(sd);
		try 
		{
		  DFService.register(this, listadoChicas);
		}
		catch (FIPAException fe) 
		{
		  fe.printStackTrace();
		}
		
		alcoholismoInicial();
		
		System.out.println("[Agente buscona] " + getLocalName() + " ha entrado al bar, y esta " + nivel[borracha] + " borracha.");
		
		// Aado behaviour para tratar los query que entran
		addBehaviour(new Escuchar());
		addBehaviour(new PedirCopa());
			

	}//fin setup
	
	
	protected void alcoholismoInicial()
	{	
		Random randomGenerator = new Random();    
		borracha = randomGenerator.nextInt(3); //random 0-1-2			
	}
	
	
	private class Escuchar extends CyclicBehaviour 
	{
	  public void action()
	  {
		  MessageTemplate mt = MessageTemplate.MatchPerformative( ACLMessage.CFP );
		  ACLMessage msg = myAgent.receive( mt );
		  
			if (msg != null)
			{
				if ( msg.getSender().getLocalName().equals("DJ"))
				{
					doDelete();
				}				
				else
				{
				  // Se ha recibido un mensaje y lo proceso
				  ACLMessage reply = msg.createReply();
				  
				  System.out.println("\n["+getLocalName() +"] Un desconocido esta hablando conmigo, a ver que quiere jiji.");
				  
			
				  if ( borracha != 0 ) // 0=sin alcohol en el cuerpo
				  {
					 reply.setPerformative(ACLMessage.PROPOSE);
					 System.out.println("\n["+getLocalName() +"] >>> ["+ msg.getSender().getLocalName() +"] Invitame a una copa y me lo pienso."  );
				  }
				  else
				  {
					//  como no esta borracha, le decimos que nos deje tranquilos
					
					reply.setPerformative( ACLMessage.REFUSE );
					System.out.println("\n["+getLocalName() +"] No eres mi tipo, dejame en paz.!!" );
				  }
				
				 doWait(5000);
				  myAgent.send(reply);
			  }
			}
			else 
			{
				block();
			}
		}
	  
	}  // Fin Escuchar
	
	
	
	private class PedirCopa extends CyclicBehaviour
	{
	
	  public void action() 
	  {
		  MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.ACCEPT_PROPOSAL);
		  ACLMessage mensaje = myAgent.receive(mt);
		  
	    if (mensaje != null)
		{
	      // El ligon nos ha comprado una copa
		  
	      String bebida = mensaje.getContent();
	      ACLMessage reply = mensaje.createReply();
	      
		  if ( bebida.equals("rosa"))
		  {
			Random randomGenerator = new Random();    
			int suerte = randomGenerator.nextInt(3); //random 0-1-2

			if ( suerte != 0 ) //premio
			{
				reply.setPerformative( ACLMessage.INFORM );
				System.out.println("["+getLocalName() +"] " + mensaje.getSender().getLocalName() + ", que rosa mas bonita, eres todo un romantico." );
			}
			else//adios
			{
				reply.setPerformative( ACLMessage.FAILURE );
				System.out.println("["+getLocalName() +"] Lo siento, pero con una triste rosa no me voy a ir contigo.");
			}
			
			
		  }
		  else
		  {
			  if ( !bebida.equals("Gintonic") ) 
			  {
				reply.setPerformative( ACLMessage.INFORM );
				System.out.println("["+getLocalName() +"] " + mensaje.getSender().getLocalName() + ", veo que te gusta ir al grano ofreciendome un " + bebida  );
			  }
			  else 
			  {
				// tengo novio
				
				reply.setPerformative( ACLMessage.FAILURE );
				System.out.println("["+getLocalName() +"] Lo siento, estaba jugando contigo, tengo novio , pero gracias por el " + bebida + " jeje.");
			  }
			}
			
		  doWait(5000);
	      myAgent.send(reply);
	    }
		  else {
		    block();
		  }
	  }
	}  // End of inner class OfferRequestsServer
	
	protected void takeDown()
	{
	
	 // Deregister from the yellow pages
		try 
		{
			DFService.deregister(this);
		}
		catch (FIPAException fe) 
		{
			fe.printStackTrace();
	
		}
	
	
	
		System.out.println( getLocalName() + " sale disparada del local." );
	}

}//fin class Ligon