package actores.behaviours;

import jade.core.Agent;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.SequentialBehaviour;
import jade.core.behaviours.WakerBehaviour;
import jade.core.behaviours.TickerBehaviour;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;

import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

public class Chinita extends Agent 
{

	protected void setup() 
	{
		
		System.out.println("\n\n[Agente Vendedora] " + getLocalName() + " ha entrado al bar, pero esta muy lejos.\n\n");
		
		
		// La introduzco en la lista de vendedoras
		
		DFAgentDescription listadoChinas = new DFAgentDescription();
		listadoChinas.setName( getAID() );
		ServiceDescription sd = new ServiceDescription();
		sd.setType("tipo-china");
		sd.setName( getLocalName() );
		listadoChinas.addServices(sd);
		try 
		{
		  DFService.register(this, listadoChinas);
		}
		catch (FIPAException fe) 
		{
		  fe.printStackTrace();
		}
	
	
	
	
		//esperando un mensaje REQUEST para desbloquear al actor
		
		final ACLMessage msg = blockingReceive(MessageTemplate.MatchPerformative(ACLMessage.REQUEST));
		
		
		//nos acercamos al joven que nos quiere comprar cosas
		

		SequentialBehaviour secuencia = new SequentialBehaviour();
		secuencia.addSubBehaviour	
		(new WakerBehaviour(this, 5000) 
		{
			protected void onWake() 
			{
				System.out.println( "\n=== Desbloqueado agente ===\n\n=== Empieza secuencia de 3 comportamientos ===\n" + myAgent.getLocalName()+" se fija en que le haces gestos para que te acerques.");
       
			} 
		});
		
		secuencia.addSubBehaviour	
		(new WakerBehaviour(this, 10000) 
		{
			protected void onWake() 
			{
				System.out.println("["+myAgent.getLocalName()+"] Vendo Gafas con luces, rosas , coronas para las princesas y polvos magicos.");
				System.out.println(" Empieza el regateo...");
       
			} 
		});
		
		secuencia.addSubBehaviour	
		(new WakerBehaviour(this, 15000) 
		{
			protected void onWake() 
			{
				System.out.println("Tras un duro regateo, "+myAgent.getLocalName()+" vende 3 rosas a cambio de 6 euros a " + msg.getSender().getLocalName() + ".");
				
				ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
				reply.addReceiver(msg.getSender());
				reply.setContent("rosas");
				send(reply);
				
				
				doDelete();
       
			} 
		});
	

		addBehaviour( secuencia );
		
		
		
		
	}
	
	protected void takeDown()
	{
	
	 	try 
		{
			DFService.deregister(this);
		}
		
		catch (FIPAException fe) 
		{
			fe.printStackTrace();
	
		}

		System.out.println("Agente "+getLocalName()+": abandona la discoteca y se va a otra.");
	}
}