package actores.behaviours;

import jade.core.Agent;
import jade.core.AID;
import jade.core.behaviours.*; 
import java.util.*;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;


public class Ligon extends Agent 
{

  
  private AID[] listaChicas; // Lista de las chicas del bar 
  private AID[] listaChinas; // Lista de las chinas del bar 
  

  private String[] bebidas= {"Gintonic","Sex on the beach"};
  
  private int dinero = 10 ;
  private int rosas = 0 ;
  private int exitos = 0;
  


	//inicializo el agente
	protected void setup()
	{
	
		
		System.out.println("[Agente ligon] " + getLocalName() + " ha entrado en la discoteca.");
		
		
		/** Aado los comportamientos **/
		
		 
		addBehaviour
			(new WakerBehaviour(this, 5000) 
			{
				protected void onWake() 
				{
					System.out.println("Mientras se toma una copa, observa la fauna de la discoteca.");
					
					//Busco las chicas busconas del bar
					addBehaviour( new BuscarChicas() );
					
				} 
			}
		);
		
			
		
		

	}//fin setup
	
	
	 protected void takeDown()
	{
		System.out.println("[Agente ligon] " + getLocalName() + " abandona la discoteca cansado.");
	}
	
	
	private class BuscarChicas extends OneShotBehaviour 
	{
		public void onStart()
		{
			System.out.println("\n==On Start==\n[" + getLocalName() + "] Esta noche ligo y algo mas fijo!.Veamos que caza toca esta noche.....");
		
		}
		
	
		public void action()
		{
			System.out.println("\n\n===================================OneShotBehaviour===================================");
			
				
			  // Actualizamos la lista de las busconas del bar
			  
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("tipo-buscona");
			  template.addServices(sd);
			  
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				System.out.println("[" + getLocalName() + "] He encontrado las siguientes chicas:");
				listaChicas = new AID[result.length];
				for (int i = 0; i < result.length; ++i)
				{
					listaChicas[i] = result[i].getName();
					System.out.println("[" + getLocalName() +"]" + listaChicas[i].getLocalName());
				}
			  }
			  catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			  System.out.println("\n\n======================================================================================");
			 
			 doWait(10000);
			 
			 addBehaviour( new Acosar() );
		}
		
	}//fin buscar chicas
	
	/** Varios steps **/
	
	private class Acosar extends Behaviour
	{
		public int onEnd()
		{
			System.out.println("\n==On End==\n[" + getLocalName() + "] Numero de exitos de esta noche... " + exitos );
			return 0;
		
		}
		private MessageTemplate tratarRespuestas; // template para recibir lo que nos respondan las chicas
		private MessageTemplate tratarChinas; 
		private int step = 0 ;
		private int i = 0 ;
				
	
		public void action()
		{
		
		//Procedo a intentar ligarme a cada chica que he encontrado
					
			switch (step) 
			{
			case 0:	 // saludo a la chica
				
				System.out.println("\n\n====================================Behaviour Multi Step====================================");
				System.out.println("\n===STEP 0   Interaccion con una chica===");
				
				System.out.println("\n\nQue tiemblen las madres, que se va a producir un intento de ligue sobre una indefensa chica.");
			
				ACLMessage cfp = new ACLMessage(ACLMessage.CFP);
			
				System.out.println("\n[" + getLocalName() +"] Voy a utilizar mis tecnicas infalibles de ligoteo con ["
									   + listaChicas[i].getLocalName() +"], seguro que no se me resiste.");
				cfp.addReceiver(listaChicas[i]);
			 
			
				cfp.setConversationId("sexy time");
				cfp.setReplyWith("cfp"+System.currentTimeMillis()); 
				myAgent.send(cfp);
			
				System.out.println("\n[" + getLocalName() +"]>>> [" + listaChicas[i].getLocalName() +"] Che pive, queres pasar un buen rato esta noche.");
			
			
			
				
				tratarRespuestas = MessageTemplate.and( MessageTemplate.MatchConversationId("sexy time")
								  ,MessageTemplate.MatchInReplyTo( cfp.getReplyWith() ) );
								  
				
				step=1;
				break;
				
			case 1: // ella me responde y analizo la respuesta
			
				System.out.println("\n===STEP 1   Analizando la respuesta de la chica===\n");
			
				ACLMessage respuesta = myAgent.receive( tratarRespuestas );
												
				if (respuesta != null) 
				{
		
				// nos acepta y quiere una copa
					if ( respuesta.getPerformative() == ACLMessage.PROPOSE ) 
					{
					
						//tengo dinero para una copa
						if ( dinero >= 10)
						{							
							dinero = dinero - 10 ;
							step = 2; 
							System.out.println("\n" + getLocalName() + " se deja 10 euros en una copa para " + listaChicas[i].getLocalName() );
							
						} 
						//no tengo dinero, pero igual tengo alguna flor
						else 
						{
							
							if( rosas > 0 )
							{
								//tengo flores
								
								ACLMessage copa = new ACLMessage( ACLMessage.ACCEPT_PROPOSAL );
								copa.addReceiver( listaChicas[i] );
								copa.setContent( "rosa" );
								copa.setConversationId("tomacopa");
								copa.setReplyWith("copa"+System.currentTimeMillis());
								myAgent.send( copa );
								rosas=rosas-1;
					
								System.out.println("\n[" + getLocalName() +"] No te puedo comprar una copa, pero aqui tienes una rosa para una rosa :)");
								// ahora nos dar la chica una respuesta
					
								tratarRespuestas = MessageTemplate.and(MessageTemplate.MatchConversationId("tomacopa"),
													MessageTemplate.MatchInReplyTo(copa.getReplyWith()));
								step = 3;
							}
							else
							{
								//no tengo flores, hay que comprar
								System.out.println("\n" + getLocalName() +" No tiene dinero para una copa ni flores, y no sabe si hay alguna vendedora cerca.");
								step = 4 ;
							}
						}	
					}
					
				// la chica nos rechaza y hay que buscar a otra victima
					if ( respuesta.getPerformative() == ACLMessage.REFUSE ) 
					{
						System.out.println("\n[" + getLocalName() +"] Tu te lo pierdes, golfa.");
						
						step = 7; 
					}
					
				}
				else 
				{
					block();
				}
				
				
				break;
						
				
			case 2:
			
				System.out.println("\n===STEP 2   Se compra una copa al tener dinero===\n");
				//le compramos la copa

				
				
				ACLMessage copa = new ACLMessage( ACLMessage.ACCEPT_PROPOSAL );
				copa.addReceiver( listaChicas[i] );
				copa.setContent( bebidas [ comprarBebida() ] );
				copa.setConversationId("tomacopa");
				copa.setReplyWith("copa"+System.currentTimeMillis());
				myAgent.send( copa );
				
				// ahora nos dar la chica una respuesta
				
				tratarRespuestas = MessageTemplate.and(MessageTemplate.MatchConversationId("tomacopa"),
									   MessageTemplate.MatchInReplyTo(copa.getReplyWith()));
				step = 3;
				break;
			
			// la decision final de la chica es...			
			case 3:
			
				System.out.println("\n===STEP 3  La chica nos responde si quiere o no tema===\n");
			
				respuesta  = myAgent.receive( tratarRespuestas );
				
				if (respuesta != null) 
				{
				
				
					// Acepta finalmente la chica
					if (respuesta.getPerformative() == ACLMessage.INFORM)
					{		
						exitos++;
						System.out.println( "[" + getLocalName() +"] y [" + listaChicas[i].getLocalName() +"] se lo pasan en grande conociendose a fondo.");
					}
					else 
					{
					// Fracaso absoluto

						System.out.println(  "[" + getLocalName() +"] Eso se dice antes, fresca!");
					}
				
				
	        	step = 7;
				
				}
				
				else 
				{
					block();
				}
				break;
			
			case 4:
				
				System.out.println("\n===STEP 4   En busqueda de vendedoras orientales===\n");
							
				
				// Actualizamos la lista de las chinas del bar
			  
				DFAgentDescription template = new DFAgentDescription();
				ServiceDescription sd = new ServiceDescription();
				sd.setType("tipo-china");
				template.addServices(sd);
			  
				try 
				{
					DFAgentDescription[] result = DFService.search(myAgent, template); 					
					listaChinas = new AID[result.length];
					
					if ( result.length > 0 )
					{
						System.out.println("[Agente ligon] He encontrado las siguientes chinas:");
						for (int i = 0; i < result.length; ++i)
						{
							listaChinas[i] = result[i].getName();
							System.out.println("[Agente ligon] " + listaChinas[i].getLocalName());
						}
						
						step=5;
					}
					else
					{
						System.out.println("[Agente ligon] No ha encontrado ninguna china.");
						System.out.println("[" + getLocalName() +"] Lo siento, no tengo dinero y eres muy fea.");
						step = 7 ;
					}
				}
				catch (FIPAException fe)
				{
					fe.printStackTrace();
				} 
								
				
				
				
				
				break;
				
				
			case 5: //regateo por rosas
			
				System.out.println("\n===STEP 5  Dialogo con la vendedora oriental===\n");
				
								
				if ( listaChinas.length > 0 )
				{				
					
						ACLMessage rosas = new ACLMessage( ACLMessage.REQUEST );
						
						rosas.addReceiver( listaChinas[0] );
						rosas.setContent( "rosas" );
						rosas.setConversationId("rosas");
						rosas.setReplyWith("rosas"+System.currentTimeMillis());
						myAgent.send( rosas );
						
						//ahora nos dar la china una respuesta
						
						// tratarChinas = MessageTemplate.and(MessageTemplate.MatchConversationId("rosas"),
											   // MessageTemplate.MatchInReplyTo(rosas.getReplyWith()));
										
				}
				
						
				while ( rosas == 0 )
				{
				
				
					DFAgentDescription template2 = new DFAgentDescription();
					ServiceDescription sd2 = new ServiceDescription();
					sd2.setType("tipo-china");
					template2.addServices(sd2);
					
						
					try 
					{
						DFAgentDescription[] result2 = DFService.search(myAgent, template2); 					
						listaChinas = new AID[result2.length];
						
						if ( result2.length == 0 )
						{
							rosas=rosas+2;
							dinero=dinero-6;
							step = 6;
						}
						
					}
					catch (FIPAException fe)
					{
						fe.printStackTrace();
					} 
					
				}
				
				
				break;
			
			case 6:
			
				System.out.println("\n===STEP 6   Ofrezco la flor a la chica===\n");
				
				
				//ahora nos dar la chica una respuesta despues de enviarle la rosa
										
				ACLMessage tomaRosa = new ACLMessage( ACLMessage.ACCEPT_PROPOSAL );
				tomaRosa.addReceiver( listaChicas[i] );
				tomaRosa.setContent( "rosa" );
				tomaRosa.setConversationId("rosas");
				tomaRosa.setReplyWith("rosas"+System.currentTimeMillis());
				myAgent.send( tomaRosa );
		
				
		
				tratarRespuestas = MessageTemplate.and(MessageTemplate.MatchConversationId("rosas"),
							   MessageTemplate.MatchInReplyTo(tomaRosa.getReplyWith()));
				step = 3;
					
						
			
				break;
				
			case 7:			
				
				System.out.println("\n===STEP 7   Comprobacion de si hay mas chicas disponibles===\n");				
				if ( i < ( listaChicas.length  - 1 ) )
				{
				
					System.out.println("["+myAgent.getLocalName()+"] Mejor tomar el aire un poco antes de seguir a tope.");
				
					doWait(20000);
				
				
					i++;
					step = 0 ;
				}
				else
					step = 8 ;
					
				break;
			
			}//fin switch
			
		}//fin action	

		//Se queda en el action, hasta que done sea true
		public boolean done() 
		{
			if( step == 8 ) 
			{
				doDelete();
			}
			return  ( step == 8 );			
		}		
		
		
	}  // Fin acosar
	
	
	
	protected int comprarBebida()
	{	
		Random randomGenerator = new Random();    
		return randomGenerator.nextInt(2); //random 0-1			
	}
	

	
	

}//fin class Ligon